Index: /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComSlice.h	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComSlice.h	(revision 1373)
@@ -1384,8 +1384,9 @@
   /// VPS EXTENSION 2 SYNTAX ELEMENTS
   Int     getDepthId                   ( Int layerIdInNuh)             const    { return getScalabilityId( getLayerIdInVps(layerIdInNuh), DEPTH_ID ); }
-#if NH_3D                                                             
+#if NH_3D_VSO                                                             
   Bool    getVpsDepthFlag              ( Int layerIdInNuh)             const    { return (getDepthId( layerIdInNuh ) > 0);  }
-  Int     getLayerIdInNuh              ( Int viewIndex, Bool depthFlag ) const;   
-          
+  Int     getLayerIdInNuh              ( Int viewIndex, Bool depthFlag, Int auxId ) const;   
+#endif
+#if NH_3D
   Void    createCamPars                ( Int iNumViews );  
   Void    initCamParaVPS               ( Int vOIdxInVps, Int numCp, Bool cpInSliceSegmentHeaderFlag, Int* cpRefVoi, Int** aaiScale, Int** aaiOffset );                                                
@@ -2700,5 +2701,5 @@
   Int        m_viewId;
   Int        m_viewIndex; 
-#if NH_3D
+#if NH_3D_VSO
   Bool       m_isDepth;
 #endif
@@ -2752,5 +2753,9 @@
   Bool       m_cpAvailableFlag; 
   Int        m_numViews; 
+#endif
+#if NH_3D_QTL
   TComPic*   m_ivPicsCurrPoc [2][MAX_NUM_LAYERS];  
+#endif
+#if NH_3D
   Int**      m_depthToDisparityB; 
   Int**      m_depthToDisparityF; 
@@ -2850,5 +2855,8 @@
   Int                         getNumCurCmpLIds( )                      const         { return (Int) m_inCmpRefViewIdcs.size();                       }
   TComPic*                    getIvPic( Bool depthFlag, Int viewIndex) const         { return  m_ivPicsCurrPoc[ depthFlag ? 1 : 0 ][ viewIndex ];    }
+#endif
+#if NH_3D_QTL
   TComPic*                    getTexturePic       ()                                 { return  m_ivPicsCurrPoc[0][ m_viewIndex ];                    }
+
 #endif                            
 #if NH_3D_IC                                                                                                                                          
@@ -3155,9 +3163,14 @@
   Int                         getFirstTRefIdx        ( RefPicList e )                { return  m_aiFirstTRefIdx[e];                                  }
   Void                        setFirstTRefIdx        ( RefPicList e, Int i )         { m_aiFirstTRefIdx[e]    = i;                                   }
-  Bool                        getArpRefPicAvailable  ( RefPicList e, Int viewIdx)    { return m_arpRefPicAvailable[e][getVPS()->getLayerIdInNuh(viewIdx, 0)]; }
+
+  Bool                        getArpRefPicAvailable  ( RefPicList e, Int viewIdx)    { return m_arpRefPicAvailable[e][getVPS()->getLayerIdInNuh(viewIdx, false, 0 )]; }
   IntAry1d                    getPocsInCurrRPSs()                                    { return m_pocsInCurrRPSs;                                      } 
-#endif                                                                                                                                               
+#endif                        
+#endif
+#if NH_3D_VSO
   Void                        setIsDepth            ( Bool isDepth )                 { m_isDepth = isDepth;                                          }
   Bool                        getIsDepth            () const                         { return m_isDepth;                                             }
+#endif
+#if NH_3D
   Void                        setCamparaSlice       ( Int** aaiScale = 0, Int** aaiOffset = 0 );      
 
@@ -3179,5 +3192,9 @@
   Int                         getCpInvOff( Int j )                                   { return m_aaiCodedOffset[1][j];                                }
                                                                                                                                                         
+#endif
+#if NH_3D_QTL
   Void                        setIvPicLists( TComPicLists* m_ivPicLists );                                                                              
+#endif
+#if NH_3D
   Void                        setDepthToDisparityLUTs();                                                                                                
                                                                                                                                                         
Index: /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComYuv.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComYuv.h	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibCommon/TComYuv.h	(revision 1373)
@@ -204,6 +204,8 @@
   UInt         getComponentScaleX         (const ComponentID id) const { return ::getComponentScaleX(id, m_chromaFormatIDC); }
   UInt         getComponentScaleY         (const ComponentID id) const { return ::getComponentScaleY(id, m_chromaFormatIDC); }
+#if NH_3D_VSO
+  Void         addClipPartLuma( Int bitDepth, TComYuv* pcYuvSrc0, TComYuv* pcYuvSrc1, UInt uiTrUnitIdx, UInt uiPartSize );
+#endif
 #if NH_3D
-  Void         addClipPartLuma( Int bitDepth, TComYuv* pcYuvSrc0, TComYuv* pcYuvSrc1, UInt uiTrUnitIdx, UInt uiPartSize );
 #if NH_3D_ARP
   Void         addARP                     ( TComYuv* pcYuvSrc0, TComYuv* pcYuvSrc1, UInt uiAbsPartIdx, UInt uiWidth , UInt uiHeight , Bool bClip, const BitDepths &clipBitDepths );
Index: /branches/HTM-15.2-dev/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibCommon/TypeDef.h	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibCommon/TypeDef.h	(revision 1373)
@@ -105,4 +105,5 @@
                                              // SEC_ARP_VIEW_REF_CHECK_J0037    Signaling iv_res_pred_weight_idx when the current slice has both view and temporal reference picture(s), JCT3V-J0037 item1
                                              // SEC_ARP_REM_ENC_RESTRICT_K0035    Removal of encoder restriction of ARP, JCT3V-K0035
+#define NH_3D_QTL                          1
 #define NH_3D_QTLPC                        1   // OL_QTLIMIT_PREDCODING_B0068 //JCT3V-B0068
                                               // HHI_QTLPC_RAU_OFF_C0160 JCT3V-C0160 change 2: quadtree limitation and predictive coding switched off in random access units
@@ -496,4 +497,6 @@
 typedef std::vector< std::string > StringAry1d;
 typedef std::vector< StringAry1d > StringAry2d;
+typedef std::vector< std::string > StringAry1d; 
+typedef std::vector< StringAry1d > StringAry2d; 
 typedef std::vector< Int >        IntAry1d;
 typedef std::vector< IntAry1d >   IntAry2d;
@@ -1003,5 +1006,5 @@
 };
 #endif
-#if NH_3D
+#if NH_3D_VSO
 // Renderer
 enum BlenMod
Index: /branches/HTM-15.2-dev/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1373)
@@ -1771,4 +1771,12 @@
         xG813DecProcForInterLayerRefPicSet();
       }
+      else
+      {
+#if NH_MV_FIX_INIT_NUM_ACTIVE_REF_LAYER_PICS
+        TComDecodedRps* decRps = m_pcPic->getDecodedRps(); 
+        decRps->m_numActiveRefLayerPics0 = 0;
+        decRps->m_numActiveRefLayerPics1 = 0;      
+#endif
+      }
     }
   }
Index: /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncCfg.h	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncCfg.h	(revision 1373)
@@ -46,5 +46,5 @@
 #include "TLibCommon/TComSlice.h"
 #include <assert.h>
-#if NH_3D
+#if NH_3D_VSO
 #include "TAppCommon/TAppComCamPara.h"
 #include "TLibRenderer/TRenModSetupStrParser.h"
@@ -469,11 +469,11 @@
 #endif 
 
-#if NH_3D
+#if NH_3D_VSO
   Bool      m_isDepth;
+  Bool      m_isAuxDepth; 
 
   //====== Camera Parameters ======
   TAppComCamPara* m_cameraParameters; 
   
-#if NH_3D_VSO
   //====== View Synthesis Optimization ======
   TRenModSetupStrParser* m_renderModelParameters; 
@@ -492,4 +492,5 @@
   Double    m_dDispCoeff;
 #endif
+#if NH_3D
 
   Bool      m_bUseIC;
@@ -498,7 +499,10 @@
   Bool      m_useSDC;
   Bool      m_useDLT;
+#endif
+#if NH_3D_QTL
   Bool      m_bUseQTL;
+#endif
+#if NH_3D
   Int       m_profileIdc;
-
 #endif
 public:
@@ -511,9 +515,10 @@
   , m_viewId(-1)
   , m_viewIndex(-1)
+#if NH_3D_VSO
+  , m_isDepth(false)
+  , m_isAuxDepth(false)
+  , m_bUseVSO(false)
+#endif
 #if NH_3D
-  , m_isDepth(false)
-#if NH_3D_VSO
-  , m_bUseVSO(false)
-#endif
   , m_profileIdc( -1 )
 #endif
@@ -561,7 +566,11 @@
   Void      setViewIndex                     ( Int viewIndex  )   { m_viewIndex  = viewIndex;  }
   Int       getViewIndex                     ()                   { return m_viewIndex;    }
-#if NH_3D
+#if NH_3D_VSO
   Void      setIsDepth                       ( Bool isDepth )   { m_isDepth = isDepth; }
   Bool      getIsDepth                       ()                 { return m_isDepth; }
+  Void      setIsAuxDepth                    ( Bool isAuxDepth ) { m_isAuxDepth = isAuxDepth; }
+  Bool      getIsAuxDepth                       ()               { return m_isAuxDepth; }
+
+
 #endif
 #endif
@@ -1188,5 +1197,5 @@
   UInt      getSummaryVerboseness( ) const                           { return m_summaryVerboseness; }
 
-#if NH_3D
+#if NH_3D_VSO
   // Only flags that are not in the SPS3dExtension should go here. 
   /// 3D Tools 
@@ -1194,6 +1203,4 @@
  //==== CAMERA PARAMETERS  ==========
   Void      setCameraParameters             ( TAppComCamPara* c) { m_cameraParameters   = c; }
-
-#if NH_3D_VSO
  //==== VSO  ==========
   Void      setRenderModelParameters ( TRenModSetupStrParser* c ) { m_renderModelParameters = c; }
@@ -1225,5 +1232,5 @@
   Void      setDispCoeff                    ( Double  d )   { m_dDispCoeff  = d; }
 #endif // NH_3D_VSO
-
+#if NH_3D
   Bool      getUseDMM                       ()        { return m_useDMM; }
   Void      setUseDMM                       ( Bool b) { m_useDMM = b;    }
@@ -1233,7 +1240,11 @@
   Bool      getUseDLT                       ()        { return m_useDLT; }
   Void      setUseDLT                       ( Bool b) { m_useDLT = b;    }
-
+#endif
+
+#if NH_3D_QTL
   Void      setUseQTL                       ( Bool b ) { m_bUseQTL = b;    }
   Bool      getUseQTL                       ()         { return m_bUseQTL; }
+#endif
+#if NH_3D
 
   Void      setProfileIdc( Int a )    { assert( a == 1 || a == 6 || a == 8 ); m_profileIdc = a;  }
Index: /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1373)
@@ -420,7 +420,10 @@
   const UInt fastDeltaQPCuMaxSize    = Clip3(sps.getMaxCUHeight()>>sps.getLog2DiffMaxMinCodingBlockSize(), sps.getMaxCUHeight(), 32u);
 
-
+#if NH_3D_QTL
 #if NH_3D_QTLPC
   Bool  bLimQtPredFalg    = pcPic->getSlice(0)->getQtPredFlag(); 
+#else
+  Bool  bLimQtPredFalg    = false;
+#endif
   TComPic *pcTexture      = rpcBestCU->getSlice()->getTexturePic();
 
@@ -437,5 +440,5 @@
   m_ppcOrigYuv[uiDepth]->copyFromPicYuv( pcPic->getPicYuvOrg(), rpcBestCU->getCtuRsAddr(), rpcBestCU->getZorderIdxInCtu() );
 
-#if NH_3D_QTLPC  
+#if NH_3D_QTL  
   Bool    bTrySplit     = true;
   Bool    bTrySplitDQP  = true;
@@ -534,5 +537,5 @@
       }
 
-#if NH_3D_QTLPC
+#if NH_3D_QTL
       bTrySplit    = true;
 #endif
@@ -552,5 +555,5 @@
 
       rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_QTLPC
+#if NH_3D_QTL
       //logic for setting bTrySplit using the partition information that is stored of the texture colocated CU
 #if H_3D_FCO
@@ -734,5 +737,5 @@
 #endif
       }
-#if NH_3D_QTLPC      
+#if NH_3D_QTL
       if(depthMapDetect && !bIntraSliceDetect && !rapPic && ( m_pcEncCfg->getUseQTL() || bLimQtPredFalg ))
       {
@@ -789,5 +792,5 @@
           {
             if( uiDepth == sps.getLog2DiffMaxMinCodingBlockSize() && doNotBlockPu
-#if NH_3D_QTLPC
+#if NH_3D_QTL
                 && bTrySplit
 #endif
@@ -809,5 +812,5 @@
 
           if(doNotBlockPu
-#if NH_3D_QTLPC
+#if NH_3D_QTL
             && bTryNx2N
 #endif
@@ -830,5 +833,5 @@
           }
           if(doNotBlockPu
-#if NH_3D_QTLPC
+#if NH_3D_QTL
             && bTry2NxN
 #endif
@@ -871,5 +874,5 @@
             {
               if(doNotBlockPu
-#if NH_3D_QTLPC
+#if NH_3D_QTL
                 && bTry2NxN
 #endif
@@ -891,5 +894,5 @@
               }
               if(doNotBlockPu
-#if NH_3D_QTLPC
+#if NH_3D_QTL
                 && bTry2NxN
 #endif
@@ -917,5 +920,5 @@
             {
               if(doNotBlockPu
-#if NH_3D_QTLPC
+#if NH_3D_QTL
                 && bTry2NxN
 #endif
@@ -939,5 +942,5 @@
               }
               if(doNotBlockPu
-#if NH_3D_QTLPC
+#if NH_3D_QTL
                 && bTry2NxN
 #endif
@@ -966,5 +969,5 @@
             {
               if(doNotBlockPu
-#if NH_3D_QTLPC
+#if NH_3D_QTL
                 && bTryNx2N
 #endif
@@ -987,5 +990,5 @@
               }
               if(doNotBlockPu
-#if NH_3D_QTLPC
+#if NH_3D_QTL
                 && bTryNx2N
 #endif
@@ -1007,5 +1010,5 @@
             {
               if(doNotBlockPu
-#if NH_3D_QTLPC
+#if NH_3D_QTL
                 && bTryNx2N
 #endif
@@ -1027,5 +1030,5 @@
               }
               if(doNotBlockPu
-#if NH_3D_QTLPC
+#if NH_3D_QTL
                 && bTryNx2N
 #endif
@@ -1048,5 +1051,5 @@
 
 #else
-#if NH_3D_QTLPC
+#if NH_3D_QTL
             if (bTry2NxN)
             {
@@ -1063,5 +1066,5 @@
             rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
-#if NH_3D_QTLPC
+#if NH_3D_QTL
             }
             if (bTryNx2N)
@@ -1078,5 +1081,5 @@
             rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
-#if NH_3D_QTLPC
+#if NH_3D_QTL
             }
 #endif
@@ -1134,5 +1137,5 @@
           if( uiDepth == sps.getLog2DiffMaxMinCodingBlockSize() )
           {
-#if NH_3D_QTLPC //Try IntraNxN
+#if NH_3D_QTL //Try IntraNxN
               if(bTrySplit)
               {
@@ -1150,5 +1153,5 @@
               rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
             }
-#if NH_3D_QTLPC
+#if NH_3D_QTL
               }
 #endif
@@ -1252,5 +1255,5 @@
   const Bool bSubBranch = bBoundary || !( m_pcEncCfg->getUseEarlyCU() && rpcBestCU->getTotalCost()!=MAX_DOUBLE && rpcBestCU->isSkipped(0) );
 #endif
-#if NH_3D_QTLPC
+#if NH_3D_QTL
   if( bSubBranch && uiDepth < sps.getLog2DiffMaxMinCodingBlockSize() && (!getFastDeltaQp() || uiWidth > fastDeltaQPCuMaxSize || bBoundary) && bTrySplitDQP )
 #else
Index: /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 1373)
@@ -1434,6 +1434,9 @@
     Int numDirectRefLayers = vps    ->getNumDirectRefLayers( getLayerId() );
 #endif
+#if NH_3D_QTL
+    pcSlice->setIvPicLists( m_ivPicLists );
+#endif
 #if NH_3D
-    pcSlice->setIvPicLists( m_ivPicLists );
+
 
     Int gopNum = (pcSlice->getRapPicFlag() && getLayerId() > 0) ? MAX_GOP : iGOPid;
@@ -1654,9 +1657,11 @@
     pcRdCost->setVideoRecPicYuv( m_pcEncTop->getIvPicLists()->getPicYuv( pcSlice->getViewIndex(), false, pcSlice->getPOC(), flagRec ) );
     pcRdCost->setDepthPicYuv   ( m_pcEncTop->getIvPicLists()->getPicYuv( pcSlice->getViewIndex(), true, pcSlice->getPOC(), false ) );
-#else
-    pcRdCost->setVideoRecPicYuv( m_pcEncTop->getIvPicLists()->getPicYuv( pcSlice->getViewIndex(), false , pcSlice->getPOC(), true ) );
-    pcRdCost->setDepthPicYuv   ( m_pcEncTop->getIvPicLists()->getPicYuv( pcSlice->getViewIndex(), true  , pcSlice->getPOC(), false ) );
-#endif
-
+#else    
+    Int curAuxId     = pcSlice->getVPS()->getAuxId( getLayerId() ); 
+    Int curDepthFlag = pcSlice->getIsDepth(); 
+    assert( curAuxId == 2 || curDepthFlag  ); 
+    pcRdCost->setVideoRecPicYuv( m_pcEncTop->getIvPicLists()->getPicYuv( pcSlice->getViewIndex(), false       , 0       , pcSlice->getPOC(), true ) );
+    pcRdCost->setDepthPicYuv   ( m_pcEncTop->getIvPicLists()->getPicYuv( pcSlice->getViewIndex(), curDepthFlag, curAuxId, pcSlice->getPOC(), false ) );
+#endif
     // LGE_WVSO_A0119
     Bool bUseWVSO  = m_pcEncTop->getUseWVSO();
Index: /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncSlice.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 1373)
@@ -461,5 +461,5 @@
 
 #if NH_3D_VSO
-  m_pcRdCost->setUseLambdaScaleVSO  ( (m_pcCfg->getUseVSO() ||  m_pcCfg->getForceLambdaScaleVSO()) && m_pcCfg->getIsDepth() );
+  m_pcRdCost->setUseLambdaScaleVSO  ( (m_pcCfg->getUseVSO() ||  m_pcCfg->getForceLambdaScaleVSO()) && ( m_pcCfg->getIsDepth()  | m_pcCfg->getIsAuxDepth() ) );
   m_pcRdCost->setLambdaVSO          ( dLambda * m_pcCfg->getLambdaScaleVSO() );
 
@@ -470,5 +470,5 @@
 
   // LGE_WVSO_A0119
-  if( m_pcCfg->getUseWVSO() && m_pcCfg->getIsDepth() )
+  if( m_pcCfg->getUseWVSO() && ( m_pcCfg->getIsDepth() || m_pcCfg->getIsAuxDepth() ) )
   {
     m_pcRdCost->setDWeight  ( m_pcCfg->getDWeight()   );
@@ -713,5 +713,5 @@
 
     // compute RD cost and choose the best
-#if NH_3D
+#if NH_3D_VSO
     Double dPicRdCost = m_pcRdCost->calcRdCost( (Double)m_uiPicTotalBits, uiPicDist, DF_SSE_FRAME);
 #else
@@ -899,5 +899,5 @@
         iLastPosY = iCurPosY;         
         TEncTop* pcEncTop = (TEncTop*) m_pcCfg; // Fix this later.
-        pcEncTop->setupRenModel( pcSlice->getPOC() , pcSlice->getViewIndex(), pcSlice->getIsDepth() ? 1 : 0, iCurPosY, pcSlice->getSPS()->getMaxCUHeight() );
+        pcEncTop->setupRenModel( pcSlice->getPOC() , pcSlice->getViewIndex(), pcSlice->getIsDepth() || pcSlice->getVPS()->getAuxId( pcSlice->getLayerId()  ) ? 1 : 0, iCurPosY, pcSlice->getSPS()->getMaxCUHeight() );
       }
     }
Index: /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1373)
@@ -1565,8 +1565,23 @@
     Int iBaseViewIdx = m_cameraParameters->getBaseSortedId2Id()[ iBaseViewSIdx ];
 
-    TComPicYuv* pcPicYuvVideoRec  = m_ivPicLists->getPicYuv( iBaseViewIdx, false, iPoc, true  );
-    TComPicYuv* pcPicYuvDepthRec  = m_ivPicLists->getPicYuv( iBaseViewIdx, true , iPoc, true  );
-    TComPicYuv* pcPicYuvVideoOrg  = m_ivPicLists->getPicYuv( iBaseViewIdx, false, iPoc, false );
-    TComPicYuv* pcPicYuvDepthOrg  = m_ivPicLists->getPicYuv( iBaseViewIdx, true , iPoc, false );    
+    Int  auxId     =   getVPS()->getAuxId  ( getLayerId() );     
+    Bool depthFlag = ( getVPS()->getDepthId( getLayerId() ) == 1 ); 
+
+    if( auxId == 0 && !depthFlag  )
+    {
+      // Defaults for texture layers
+#if NH_3D
+      depthFlag = true; 
+      auxId     = 0; 
+#else
+      depthFlag = false; 
+      auxId     = 2; 
+#endif
+    }
+
+    TComPicYuv* pcPicYuvVideoRec  = m_ivPicLists->getPicYuv( iBaseViewIdx, false    , 0    , iPoc, true  );
+    TComPicYuv* pcPicYuvDepthRec  = m_ivPicLists->getPicYuv( iBaseViewIdx, depthFlag, auxId, iPoc, true  );
+    TComPicYuv* pcPicYuvVideoOrg  = m_ivPicLists->getPicYuv( iBaseViewIdx, false,     0    , iPoc, false );
+    TComPicYuv* pcPicYuvDepthOrg  = m_ivPicLists->getPicYuv( iBaseViewIdx, depthFlag, auxId, iPoc, false );    
 
     TComPicYuv* pcPicYuvVideoRef  = ( iVideoDistMode == 2 ) ? pcPicYuvVideoOrg  : NULL;
@@ -1633,5 +1648,5 @@
     if ( iOrgRefBaseViewSIdx != -1 )
     {
-      pcPicYuvOrgRef = m_ivPicLists->getPicYuv(  m_cameraParameters->getBaseSortedId2Id()[ iOrgRefBaseViewSIdx ] , false, iPoc, false );
+      pcPicYuvOrgRef = m_ivPicLists->getPicYuv(  m_cameraParameters->getBaseSortedId2Id()[ iOrgRefBaseViewSIdx ] , false, 0, iPoc, false );
       AOF ( pcPicYuvOrgRef );
     }
Index: /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenFilter.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenFilter.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenFilter.cpp	(revision 1373)
@@ -36,5 +36,5 @@
 #include "TRenFilter.h"
 #include "TRenInterpFilter.h"
-#if NH_3D
+#if NH_3D_VSO
 
 ///// COMMON /////
Index: /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenFilter.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenFilter.h	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenFilter.h	(revision 1373)
@@ -39,5 +39,5 @@
 #include "TRenImage.h"
 #include "TRenInterpFilter.h"
-#if NH_3D
+#if NH_3D_VSO
 
 typedef Int (TRenInterpFilter<REN_BIT_DEPTH>::*FpChromaIntFilt) ( Pel*, Int );
Index: /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenImage.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenImage.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenImage.cpp	(revision 1373)
@@ -37,5 +37,5 @@
 #include "TRenFilter.h"
 #include "assert.h"
-#if NH_3D
+#if NH_3D_VSO
 
 
Index: /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenImage.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenImage.h	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenImage.h	(revision 1373)
@@ -39,5 +39,5 @@
 #include "../TLibCommon/TComPicYuv.h"
 #include "TRenImagePlane.h"
-#if NH_3D
+#if NH_3D_VSO
 
 
Index: /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenImagePlane.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenImagePlane.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenImagePlane.cpp	(revision 1373)
@@ -36,5 +36,5 @@
 #include "TRenFilter.h"
 #include <string.h>
-#if NH_3D
+#if NH_3D_VSO
 
 /////// TRenImagePlane ///////
Index: /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenImagePlane.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenImagePlane.h	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenImagePlane.h	(revision 1373)
@@ -39,5 +39,5 @@
 #include "../TLibCommon/TComPicYuv.h"
 
-#if NH_3D
+#if NH_3D_VSO
 #define PelImagePlane     TRenImagePlane<Pel>
 #define DoubleImagePlane  TRenImagePlane<Double>
Index: /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenInterpFilter.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenInterpFilter.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenInterpFilter.cpp	(revision 1373)
@@ -39,5 +39,5 @@
 
 #include "TRenInterpFilter.h"
-#if NH_3D
+#if NH_3D_VSO
 
 // ====================================================================================================================
Index: /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenInterpFilter.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenInterpFilter.h	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenInterpFilter.h	(revision 1373)
@@ -44,5 +44,5 @@
 #include "TLibCommon/CommonDef.h"
 #include "assert.h"
-#if NH_3D
+#if NH_3D_VSO
 
 // ====================================================================================================================
Index: /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenModSetupStrParser.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenModSetupStrParser.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenModSetupStrParser.cpp	(revision 1373)
@@ -37,5 +37,5 @@
 #include "TRenModSetupStrParser.h"
 
-#if NH_3D
+#if NH_3D_VSO
 Int
 TRenModSetupStrParser::getNumOfModels()
Index: /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenModSetupStrParser.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenModSetupStrParser.h	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenModSetupStrParser.h	(revision 1373)
@@ -39,5 +39,5 @@
 #include "../TLibCommon/TypeDef.h"
 #include "../TAppCommon/TAppComCamPara.h"
-#if NH_3D
+#if NH_3D_VSO
 
 
Index: /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenTop.cpp
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenTop.cpp	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenTop.cpp	(revision 1373)
@@ -40,5 +40,5 @@
 #include <math.h>
 #include "../TLibCommon/CommonDef.h"
-#if NH_3D
+#if NH_3D_VSO
 
 
Index: /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenTop.h
===================================================================
--- /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenTop.h	(revision 1372)
+++ /branches/HTM-15.2-dev/source/Lib/TLibRenderer/TRenTop.h	(revision 1373)
@@ -39,5 +39,5 @@
 #include "../TLibCommon/TComPicYuv.h"
 
-#if NH_3D
+#if NH_3D_VSO
 #include <list>
 #include <vector>
